
/* Compatible models:
 *      -
 *      -
 *      -
 *      -
 *      -
 *      -
 *      -
 */

function Screen() {
}

Screen.prototype = new BasicScreenController();
Screen.prototype.constructor = Screen();


// Reference to "this" that won't get clobbered by some other "this"
//Screen.prototype.self = this;
Screen.prototype.name = "SAMSUNG_RS232";

/*
 * Timers use
 * if (timer = * ) it will load if (timer = 0) it won't load
 * Once init is called, timeouts references are stored here
 */
Screen.prototype.timers = {
    power : 1,
    channel : 0,
    schedule : 0
}

Screen.prototype.maxAttempts = {
    power : 1,
    channel : 0,
    schedule : 1
};

/******************************** PORT ********************************/
// Parser, will be executed without parameters once the port is loaded
Screen.prototype.customSerialParser = function () {
    var incommingData = new Buffer(0);
    var incommingMsgLength = 0;
	return function(emitter, buffer) {
        incommingData = Buffer.concat([incommingData, buffer]);
        if ( incommingMsgLength == 0 && incommingData.length > 0 ){
        	incommingMsgLength = incommingData[0];
        }

        if ( incommingMsgLength != 0 && incommingData.length >= incommingMsgLength ) {
        	var out = incommingData.slice(0,incommingMsgLength);
        	incommingData = incommingData.slice(length);
            emitter.emit("data", out);
        }
    };
};

//Conf
Screen.prototype.portValues = {
		name : '',
	    config : {
	            baudRate : 9600,
	            dataBits : 8,
	            stopBits : 1
	    },
	    parser :
        /*{
    		type : 'customSerialParser' ,
            delimiter : Screen.prototype.customSerialParser
	    }*/
        {
            type : 'byteLength' ,
            delimiter : 8
        }
}


//SPECIAL
Screen.prototype.group = Buffer.from ( '00' , 'hex' );


//PROTOTYPING
/******************************** INIT PROTOTYPING ********************************/
Screen.prototype.formatRemoteId = function ( id ) {
    //id = "FE"
    return Buffer.from ( ( "00" + id.toString(16)).substr(-2) , 'hex')
};
Screen.prototype.loadDriver = function ( platform ) {
    if  ( typeof RS232_driverController !== "function" ){
        eval('eval')(fs.readFileSync('./app/screenDrivers/RS232.js')+'');
    }

    return new RS232_driverController ();
};

Screen.prototype.loadPortValues = function () {} ;


/******************************** STATUS PROTOTYPING ********************************/

Screen.prototype.generatePowerQuerry = function (){
    var type = Buffer.from ( '11' , 'hex');
    var command = Buffer.from ( '00' , 'hex');
    command = Buffer.concat([ type, this.data.formated_remote_id, command ]);
    command = Buffer.concat([ this.samsungSTX, command, this.getSumChecksumMod256(command) ]);
    return command;
}

Screen.prototype.translatePowerQuerry = function ( data ){
    this.status.lastCMD = data.toString('hex');

    if (data.includes( Buffer.from ( '411101', 'hex') ) ){
        this.status.power = 1;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else if (data.includes( Buffer.from ( '411100', 'hex') )){
        this.status.power = 0;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){

            this.status.power = -1;
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
    return;
};

Screen.prototype.endPowerQuerry = function (){
    this.checkSchedule ();
    return;
};


/******************************** CHANNEL PROTOTYPING ********************************/

Screen.prototype.generateChannelQuerry = function (){
    var type = Buffer.from ( '14' , 'hex');
    var command = Buffer.from ( '00' , 'hex');
    command = Buffer.concat([ type, this.data.formated_remote_id, command ]);
    command = Buffer.concat([ this.samsungSTX, command, this.getSumChecksumMod256(command) ]);
    return command;
};
Screen.prototype.translateChannelQuerry = function ( data ){
    this.status.lastCMD = data.toString('hex');

    if (data.includes( Buffer.from( 'AD01', 'hex') )){
        this.status.channel = 'VIDEO';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD02', 'hex') )){
        this.status.channel = 'S-VIDEO';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD03', 'hex') )){
        this.status.channel = 'COMPONENT';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD04', 'hex') )){
        this.status.channel = 'CVI 2';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD05', 'hex') )){
        this.status.channel = 'VGA';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD06', 'hex') )){
        this.status.channel = 'HDMI 2';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD07', 'hex') )){
        this.status.channel = 'Display Port 2';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD08', 'hex') )){
        this.status.channel = 'USB 2';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD09', 'hex') )){
        this.status.channel = 'Card DVI-D';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD0A', 'hex') )){
        this.status.channel = 'Display Port 1';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD0B', 'hex') )){
        this.status.channel = 'Card OPS';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD0C', 'hex') )){
        this.status.channel = 'USB 1';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD0D', 'hex') )){
        this.status.channel = 'HDMI 1';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD0E', 'hex') )){
        this.status.channel = 'DVI-D';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD0F', 'hex') )){
        this.status.channel = 'HDMI 3';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD10', 'hex') )){
        this.status.channel = 'BROWSER';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD11', 'hex') )){
        this.status.channel = 'SMARTCMS';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD12', 'hex') )){
        this.status.channel = 'DMS (Digital Media Server)';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD13', 'hex') )){
        this.status.channel = 'INTERNAL STORAGE';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD14', 'hex') )){
        this.status.channel = 'Reserved';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD15', 'hex') )){
        this.status.channel = 'Reserved';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD16', 'hex') )){
        this.status.channel = 'Media Player';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD17', 'hex') )){
        this.status.channel = 'PDF Player';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else if (data.includes( Buffer.from( 'AD18', 'hex') )){
        this.status.channel = 'Custom';
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.channel = this.maxAttempts.channel;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.channel = 'Unknown';
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
};

Screen.prototype.endChannelQuerry = function (){};

/******************************** SCHEDULE PROTOTYPING ********************************/
Screen.prototype.generateScheduleQuerry  = function (){ return ""; };
Screen.prototype.translateScheduleQuerry = function ( data ){ return; };
Screen.prototype.endScheduleQuerry       = function (){
    this.attemptsCounter.schedule = this.maxAttempts.schedulereturn;
    return;
};

/******************************** MISC PROTOTYPING ********************************/
Screen.prototype.generateOnQuerry  = function (){
    var type = Buffer.from ( '11' , 'hex');
    var command = Buffer.from ( '0101' , 'hex');
    command = Buffer.concat([ type, this.data.formated_remote_id, command ]);
    command = Buffer.concat([ this.samsungSTX, command, this.getSumChecksumMod256(command) ]);
    return command;
};
Screen.prototype.translateOnQuerry = function ( data ){ return; };

Screen.prototype.generateOffQuerry  = function (){
    var type = Buffer.from ( '11' , 'hex');
    var command = Buffer.from ( '0100' , 'hex');
    command = Buffer.concat([ type, this.data.formated_remote_id, command ]);
    command = Buffer.concat([ this.samsungSTX, command, this.getSumChecksumMod256(command) ]);
    return command;
};

Screen.prototype.translateOffQuerry = function ( data ){ return; };

/******************************** FREE COMMAND PROTOTYPING ********************************/
Screen.prototype.generateFreeQuerry  = function ( commandRecived ){
    var command = Buffer.from ( commandRecived , 'hex');
    command = Buffer.concat([ this.samsungSTX, command, this.getSumChecksumMod256(command) ]);
    return command;
};

Screen.prototype.translateFreeQuerry = function ( data ){ return; };
Screen.prototype.endFreeQuerry      = function (){ return; };
